package com.miya;

import com.miya.common.util.SessionClient;

import java.sql.SQLException;

/**
 * Hello world!
 *
 */

public class Demo {

    private static final String CREATE_SOURCE_SQL = "CREATE TABLE source_table_4 (\n" +
            "  `mysql_type` STRING,\n" +
            "  `ts` TIMESTAMP(3) METADATA FROM 'timestamp'\n" +
            ") WITH (\n" +
            "  'connector' = 'kafka',\n" +
            "  'topic' = 'rds-binlog-test',\n" +
            "  'properties.bootstrap.servers' = '172.16.7.171:9092',\n" +
            "  'properties.group.id' = 'testGroup',\n" +
            "  'scan.startup.mode' = 'latest-offset',\n" +
            "  'format' = 'json'\n" +
            ")";

    private static final String CREATE_SINK_SQL = "CREATE TABLE sink_table_4 (\n" +
            "  `mysql_type` STRING\n" +
            ") WITH (\n" +
            "  'connector' = 'kafka',\n" +
            "  'topic' = 'rds-binlog-test2',\n" +
            "  'properties.bootstrap.servers' = '172.16.7.171:9092',\n" +
            "  'format' = 'csv'\n" +
            ")";


    private static final String CREATE_JOB_SQL = "insert into sink_table_4(mysql_type)  select mysql_type  from source_table_4";


    public static void main(String[] args) throws Exception {
        SessionClient session = new SessionClient(new Demo().getClass().getName(),"123.60.47.52", 8083, "streaming");


        kafka2kafka(session);

        session.close();
    }


    private static void kafka2kafka(SessionClient session) throws SQLException {
        System.out.println(session.submitStatement(CREATE_SOURCE_SQL).getResults());
        System.out.println(session.submitStatement(CREATE_SINK_SQL).getResults());
        System.out.println(session.submitStatement(CREATE_JOB_SQL).getResults());
    }
}