package com.miya.huawei;

import com.miya.common.util.SessionClient;

public class AccountPayKafkaBinlogToHBase {



    private static final String CREATE_SOURCE_SQL = "CREATE TABLE huawei_kafka_binlog_source_table (\n" +
            "saasid           STRING,\n" +
            "marketid         STRING,\n" +
            "operator_id      STRING,\n" +
            "out_id           STRING,\n" +
            "paymentplatform  STRING,\n" +
            "serveicetype     STRING,\n" +
            "total_fee        STRING,\n" +
            "status           STRING,\n" +
            "trad_desc        STRING,\n" +
            "`date`           STRING,\n" +
            "systemdate       STRING,\n" +
            "fund_bill_list   STRING,\n" +
            "buyer_logon_id   STRING,\n" +
            "buyer_user_id    STRING,\n" +
            "cashier          STRING,\n" +
            "seller_id        STRING,\n" +
            "trade_no         STRING,\n" +
            "is_subscribe     STRING,\n" +
            "isbalance        STRING,\n" +
            "posbatch         STRING,\n" +
            "invoiceno        STRING,\n" +
            "deductionfee     STRING,\n" +
            "merchantdiscount STRING,\n" +
            "otherdescount    STRING,\n" +
            "barcode          STRING,\n" +
            "goodstag         STRING,\n" +
            "rds_id           STRING,\n" +
            "rds_name         STRING,\n" +
            "mqstatus         STRING,\n" +
            "trade_type       STRING,\n" +
            "notify_url       STRING,\n" +
            "currency         STRING,\n" +
            "settlementid     STRING\n" +
            ") WITH (\n" +
            "  'connector' = 'kafka',\n" +
            "  'topic' = 'rds-binlog-test',\n" +
            "  'properties.bootstrap.servers' = '172.16.7.171:9092,172.16.7.8:9092,172.16.7.85:9092',\n" +
            "  'properties.group.id' = 'flink-accountpay-binlog',\n" +
            "  'scan.startup.mode' = 'earliest-offset',\n" +
            "  'json.fail-on-missing-field' = 'false',\n" +
            "  'json.ignore-parse-errors' = 'true' ," +
            "  'format' = 'json'\n" +
            ")";

    private static final String CREATE_SOURCE_SQL0 = "CREATE TABLE huawei_kafka_binlog_source_table0 (\n" +
            "saasid           STRING,\n" +
            "marketid         STRING,\n" +
            "operator_id      STRING,\n" +
            "out_id           STRING,\n" +
            "paymentplatform  STRING,\n" +
            "serveicetype     STRING,\n" +
            "total_fee        STRING,\n" +
            "status           STRING,\n" +
            "trad_desc        STRING,\n" +
            "`date`           STRING,\n" +
            "systemdate       STRING,\n" +
            "fund_bill_list   STRING,\n" +
            "buyer_logon_id   STRING,\n" +
            "buyer_user_id    STRING,\n" +
            "cashier          STRING,\n" +
            "seller_id        STRING,\n" +
            "trade_no         STRING,\n" +
            "is_subscribe     STRING,\n" +
            "isbalance        STRING,\n" +
            "posbatch         STRING,\n" +
            "invoiceno        STRING,\n" +
            "deductionfee     STRING,\n" +
            "merchantdiscount STRING,\n" +
            "otherdescount    STRING,\n" +
            "barcode          STRING,\n" +
            "goodstag         STRING,\n" +
            "rds_id           STRING,\n" +
            "rds_name         STRING,\n" +
            "mqstatus         STRING,\n" +
            "trade_type       STRING,\n" +
            "notify_url       STRING,\n" +
            "currency         STRING,\n" +
            "settlementid     STRING\n" +
            ") WITH (\n" +
            "  'connector' = 'kafka',\n" +
            "  'topic' = 'rds-binlog-test0',\n" +
            "  'properties.bootstrap.servers' = '172.16.7.171:9092,172.16.7.8:9092,172.16.7.85:9092',\n" +
            "  'properties.group.id' = 'flink-accountpay-binlog',\n" +
            "  'scan.startup.mode' = 'earliest-offset',\n" +
            "  'json.fail-on-missing-field' = 'false',\n" +
            "  'json.ignore-parse-errors' = 'true' ," +
            "  'format' = 'json'\n" +
            ")";

    private static final String CREATE_SINK_SQL = "CREATE TABLE huawei_hbase_sink_table (\n" +
            " rowkey STRING,\n" +
            " accountpay_columns ROW<saasid          STRING,\n" +
            "                               marketid         STRING,\n" +
            "                               operator_id      STRING,\n" +
            "                               out_id           STRING,\n" +
            "                               paymentplatform  STRING,\n" +
            "                               serveicetype     STRING,\n" +
            "                               total_fee        STRING,\n" +
            "                               status           STRING,\n" +
            "                               trad_desc        STRING,\n" +
            "                               `date`           STRING,\n" +
            "                               systemdate       STRING,\n" +
            "                               fund_bill_list   STRING,\n" +
            "                               buyer_logon_id   STRING,\n" +
            "                               buyer_user_id    STRING,\n" +
            "                               cashier          STRING,\n" +
            "                               seller_id        STRING,\n" +
            "                               trade_no         STRING,\n" +
            "                               is_subscribe     STRING,\n" +
            "                               isbalance        STRING,\n" +
            "                               posbatch         STRING,\n" +
            "                               invoiceno        STRING,\n" +
            "                               deductionfee     STRING,\n" +
            "                               merchantdiscount STRING,\n" +
            "                               otherdescount    STRING,\n" +
            "                               barcode          STRING,\n" +
            "                               goodstag         STRING,\n" +
            "                               rds_id           STRING,\n" +
            "                               rds_name         STRING,\n" +
            "                               mqstatus         STRING,\n" +
            "                               trade_type       STRING,\n" +
            "                               notify_url       STRING,\n" +
            "                               currency         STRING,\n" +
            "                               settlementid     STRING>,\n" +
            " PRIMARY KEY (rowkey) NOT ENFORCED\n" +
            ") WITH (\n" +
            " 'connector' = 'hbase-2.2',\n" +
            " 'table-name' = 'original:accountpay',\n" +
            " 'zookeeper.quorum' = '172.16.130.64:2181,172.16.128.15:2181,172.16.129.113:2181'" +
            ")" ;

    private static final String CREATE_JOB_SQL = "INSERT INTO huawei_hbase_sink_table\n" +
            "SELECT " +
            "   CONCAT( CAST( (MOD(CAST(DATE_FORMAT(`date`,'yyyyMMdd') AS INT),10)) AS  STRING ) , '~' , DATE_FORMAT(`date`,'yyyyMMdd'),'~' ,trade_no) ," +
            "    ROW(" +
            "saasid           ,\n" +
            "marketid         ,\n" +
            "operator_id      ,\n" +
            "out_id           ,\n" +
            "paymentplatform  ,\n" +
            "serveicetype     ,\n" +
            "total_fee        ,\n" +
            "status           ,\n" +
            "trad_desc        ,\n" +
            "`date`             ,\n" +
            "systemdate       ,\n" +
            "fund_bill_list   ,\n" +
            "buyer_logon_id   ,\n" +
            "buyer_user_id    ,\n" +
            "cashier          ,\n" +
            "seller_id        ,\n" +
            "trade_no         ,\n" +
            "is_subscribe     ,\n" +
            "isbalance        ,\n" +
            "posbatch         ,\n" +
            "invoiceno        ,\n" +
            "deductionfee     ,\n" +
            "merchantdiscount ,\n" +
            "otherdescount    ,\n" +
            "barcode          ,\n" +
            "goodstag         ,\n" +
            "rds_id           ,\n" +
            "rds_name         ,\n" +
            "mqstatus         ,\n" +
            "trade_type       ,\n" +
            "notify_url       ,\n" +
            "currency         ,\n" +
            "settlementid   "+
            "     ) FROM " +
            " (select * from huawei_kafka_binlog_source_table union all " +
            "  select * from huawei_kafka_binlog_source_table0" +
            ") ";


    public static void main(String[] args) throws Exception {
        SessionClient session = new SessionClient(new AccountPayKafkaBinlogToHBase().getClass().getName(),"123.60.47.52", 8083, "streaming");


        System.out.println(session.submitStatement(CREATE_SOURCE_SQL).getResults());
        System.out.println(session.submitStatement(CREATE_SOURCE_SQL0).getResults());
        System.out.println(session.submitStatement(CREATE_SINK_SQL).getResults());
        System.out.println(session.submitStatement(CREATE_JOB_SQL).getResults());


        session.close();
    }

}
