package com.miya.huawei;

import com.miya.common.util.SessionClient;

public class KafkaMiniProgramLogsToHBase {

    private static final String CREATE_SOURCE_SQL = "CREATE TABLE huawei_kafka_miniprogramlogs_source_table (\n" +
            "  `mysql_type` STRING,\n" +
            "  `ts` TIMESTAMP(3) METADATA FROM 'timestamp'\n" +
            ") WITH (\n" +
            "  'connector' = 'kafka',\n" +
            "  'topic' = 'rds-binlog-test',\n" +
            "  'properties.bootstrap.servers' = '172.16.7.171:9092',\n" +
            "  'properties.group.id' = 'testGroup',\n" +
            "  'scan.startup.mode' = 'earliest-offset',\n" +
            "  'format' = 'json'\n" +
            ")";


    private static final String CREATE_SINK_SQL = "CREATE TABLE huawei_hbase_sink_table (\n" +
            " rowkey INT,\n" +
            " family1 ROW<q1 STRING>,\n" +
            " PRIMARY KEY (rowkey) NOT ENFORCED\n" +
            ") WITH (\n" +
            " 'connector' = 'hbase-2.2',\n" +
            " 'table-name' = 'mytable',\n" +
            " 'zookeeper.quorum' = '172.16.128.133:2181'\n" +
            ")" ;



    private static final String CREATE_JOB_SQL = "INSERT INTO huawei_hbase_sink_table\n" +
            "SELECT CAST(mysql_type as INT),ROW(mysql_type) FROM huawei_kafka_miniprogramlogs_source_table";

    public static void main(String[] args) throws Exception {
        SessionClient session = new SessionClient(new KafkaMiniProgramLogsToHBase().getClass().getName(),"123.60.47.52", 8083, "streaming");


        System.out.println(session.submitStatement(CREATE_SOURCE_SQL).getResults());
        System.out.println(session.submitStatement(CREATE_SINK_SQL).getResults());
        System.out.println(session.submitStatement(CREATE_JOB_SQL).getResults());


        session.close();
    }

}
