package com.miya.huawei;

import com.miya.common.util.SessionClient;

public class ReturnPayKafkaBinlogToHBase {



    private static final String CREATE_SOURCE_SQL = "CREATE TABLE huawei_kafka_binlog_source_table (\n" +
            "saasid           STRING  ,\n" +
            "marketid         STRING  ,\n" +
            "operator_id      STRING  ,\n" +
            "out_id           STRING  ,\n" +
            "out_request_no   STRING  ,\n" +
            "paymentplatform  STRING  ,\n" +
            "serveicetype     STRING  ,\n" +
            "total_fee        STRING  ,\n" +
            "status           STRING  ,\n" +
            "trad_desc        STRING  ,\n" +
            "date             STRING  ,\n" +
            "miyadate         STRING,\n" +
            "retotal_fee      STRING  ,\n" +
            "cashier          STRING  ,\n" +
            "posbatch         STRING  ,\n" +
            "invoiceno        STRING  ,\n" +
            "fundbilllist     STRING  ,\n" +
            "seller_id        STRING  ,\n" +
            "trade_no         STRING  ,\n" +
            "orderfee         STRING  ,\n" +
            "rds_id           STRING  ,\n" +
            "rds_name         STRING  ,\n" +
            "currency         STRING  ,\n" +
            "settlementid     STRING  ,\n" +
            "trade_type       STRING  ,\n" +
            "deductionfee     STRING  ,\n" +
            "merchantdiscount STRING  ,\n" +
            "otherdescount    STRING    "+
            ") WITH (\n" +
            "  'connector' = 'kafka',\n" +
            "  'topic' = 'returnpay',\n" +
            "  'properties.bootstrap.servers' = '10.0.1.227:9092,10.0.1.226:9092,10.0.1.228:9092',\n" +
            "  'properties.group.id' = 'flink-returnpay-binlog',\n" +
            "  'scan.startup.mode' = 'earliest-offset',\n" +
            "  'json.fail-on-missing-field' = 'false',\n" +
            "  'json.ignore-parse-errors' = 'true' ," +
            "  'format' = 'json'\n" +
            ")";

    private static final String CREATE_SINK_SQL = "CREATE TABLE huawei_hbase_sink_table (\n" +
            " rowkey STRING,\n" +
            " returnpay_columns ROW<saasid          STRING,\n" +
            "                        marketid         STRING  ,\n" +
            "                        operator_id      STRING  ,\n" +
            "                        out_id           STRING  ,\n" +
            "                        out_request_no   STRING  ,\n" +
            "                        paymentplatform  STRING  ,\n" +
            "                        serveicetype     STRING  ,\n" +
            "                        total_fee        STRING  ,\n" +
            "                        status           STRING  ,\n" +
            "                        trad_desc        STRING  ,\n" +
            "                        date             STRING  ,\n" +
            "                        miyadate         STRING,\n" +
            "                        retotal_fee      STRING  ,\n" +
            "                        cashier          STRING  ,\n" +
            "                        posbatch         STRING  ,\n" +
            "                        invoiceno        STRING  ,\n" +
            "                        fundbilllist     STRING  ,\n" +
            "                        seller_id        STRING  ,\n" +
            "                        trade_no         STRING  ,\n" +
            "                        orderfee         STRING  ,\n" +
            "                        rds_id           STRING  ,\n" +
            "                        rds_name         STRING  ,\n" +
            "                        currency         STRING  ,\n" +
            "                        settlementid     STRING  ,\n" +
            "                        trade_type       STRING  ,\n" +
            "                        deductionfee     STRING  ,\n" +
            "                        merchantdiscount STRING  ,\n" +
            "                        otherdescount    STRING  ," +
            "                         PRIMARY KEY (rowkey) NOT ENFORCED\n" +
            ") WITH (\n" +
            " 'connector' = 'hbase-2.2',\n" +
            " 'table-name' = 'original:returnpay',\n" +
            " 'zookeeper.quorum' = '172.16.130.64:2181,172.16.128.15:2181,172.16.129.113:2181'" +
            ")" ;


    private static final String CREATE_JOB_SQL = "INSERT INTO huawei_hbase_sink_table\n" +
            "SELECT " +
            "   CONCAT( CAST( (MOD(CAST(DATE_FORMAT(`date`,'yyyyMMdd') AS INT),10)) AS  STRING ) , '~' , DATE_FORMAT(`date`,'yyyyMMdd'),'~' ,trade_no) ," +
            "   ROW(" +
            "saasid           ,\n" +
            "marketid         ,\n" +
            "operator_id      ,\n" +
            "out_id           ,\n" +
            "out_request_no   ,\n" +
            "paymentplatform  ,\n" +
            "serveicetype     ,\n" +
            "total_fee        ,\n" +
            "status           ,\n" +
            "trad_desc        ,\n" +
            "date             ,\n" +
            "miyadate         ,\n" +
            "retotal_fee      ,\n" +
            "cashier          ,\n" +
            "posbatch         ,\n" +
            "invoiceno        ,\n" +
            "fundbilllist     ,\n" +
            "seller_id        ,\n" +
            "trade_no         ,\n" +
            "orderfee         ,\n" +
            "rds_id           ,\n" +
            "rds_name         ,\n" +
            "currency         ,\n" +
            "settlementid     ,\n" +
            "trade_type       ,\n" +
            "deductionfee     ,\n" +
            "merchantdiscount ,\n" +
            "otherdescount    \n" +
            "     ) FROM huawei_kafka_binlog_source_table";



    public static void main(String[] args) throws Exception {
        SessionClient session = new SessionClient(new ReturnPayKafkaBinlogToHBase().getClass().getName(),"123.60.47.52", 8083, "streaming");


        System.out.println(session.submitStatement(CREATE_SOURCE_SQL).getResults());
        System.out.println(session.submitStatement(CREATE_SINK_SQL).getResults());
        System.out.println(session.submitStatement(CREATE_JOB_SQL).getResults());


        session.close();
    }

}
